﻿# Uhr-Gui-AL.py

class Zaehler:
    def __init__(self, maximalWert):
        self.stand=0
        self.maximalWert=maximalWert

    # der muss zaehlen können
    # die Rückgabewerte sind für die Überträge
    def zaehle(self):
        self.stand+=1
        if self.stand==self.maximalWert:
            self.stand=0
            return True
        else: return False
        
    # und den stand anzeigen können
    def zeigeStand(self):
        return self.stand

# und eine Klasse Uhr, die sich drei Zaehler beschafft
class Uhr:
    def __init__(self):
        self.stunden=Zaehler(24)
        self.minuten=Zaehler(60)
        self.sekunden=Zaehler(60)

    # die Uhr muss auch zaehlen können
    def zaehle(self):
        if self.sekunden.zaehle():
            if self.minuten.zaehle():
                self.stunden.zaehle()
        
    # und den stand anzeigen können
    def zeigeStand(self):
        return (self.stunden.stand, self.minuten.stand, self.sekunden.stand)


# ---------------GUI-Abschnitt----------------------------------------------
import wx
import time
import _thread # bei Py2 thread


class Fenster(wx.Frame):
    """
    Die Klasse Fenster erzeugt einen Frame.
    """
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title,
                          pos=(100, 100), size=(300, 200))
        self.uhrThread=None
        self.uhr=None
        self.anhalten=True

        # Erzeugt die Komponente Menuezeile [menubar]
        menuBar = wx.MenuBar()
        # und erzeuge fuer die Menuezeile zwei Menuetitel.
        menu1 = wx.Menu()
        menu2 =wx.Menu()

        # Hier wird ein Menuepunkt in den ersten oben erzeugten Menuetitel
        # eingefuegt. [add an item to the menu]
        # Mit \tKeyName wird ein Auswahlbuchstabe definiert, zudem auch automatisch
        # durch die vordefinierte ID die Ereignisbehandlung generiert.
        # Der Text im dritten Parameter wird in der Statuszeile angezeigt.
        menu1.Append(wx.ID_EXIT, "B&eenden\tAlt-E", "Schliessen der Anwendung")

        # binde den Menuepunkt an seine Ereignisbehandlung [event handler]
        self.Bind(wx.EVT_MENU, self.OnTimeToClose, id=wx.ID_EXIT)

        # Fuege das Menue der Menuezeile hinzu.
        menuBar.Append(menu1, "&Datei")
        menuBar.Append(menu2, "&Hilfe")

        # als Menue-Zeile zuweisen
        self.SetMenuBar(menuBar)
        # Anlegen der Statuszeile [z.B. fuer die oben definierten Meldungen]
        self.CreateStatusBar()
        
        # Erzeuge die Oberflaeche [wxPanel] fuer die hinzuzufuegenden Elemente.
        panel = wx.Panel(self)

        # Beschriftungen
        text = wx.StaticText(panel, -1, "Uhr")
        text.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        text.SetSize(text.GetBestSize())

        textStunden = wx.StaticText(panel, -1, "Stunden")
        textStunden.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        textStunden.SetSize(text.GetBestSize())

        textMinuten = wx.StaticText(panel, -1, "Minuten")
        textMinuten.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        textMinuten.SetSize(text.GetBestSize())

        textSekunden = wx.StaticText(panel, -1, "Sekunden")
        textSekunden.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        textSekunden.SetSize(text.GetBestSize())

        # Textfelder zur Eingabe und Ausgabe 
        self.textfeld1 = wx.TextCtrl(panel, -1, "00", size=(50, -1))
        self.textfeld2 = wx.TextCtrl(panel, -1, "00", size=(50, -1))
        self.textfeld3 = wx.TextCtrl(panel, -1, "00", size=(50, -1))

        # Buttons:
        # ein Button zum Starten und Stoppen
        startBtn = wx.Button(panel, -1, " start / stopp ")
        
        # Ein Button auf der Oberflaeche zum Beenden der Anwendung ist immer hilfreich.
        endeBtn = wx.Button(panel, -1, "   Beenden   ")
        
        # Verbinden der Ereignisbehandlung mit den Buttons [event-handler]
        self.Bind(wx.EVT_BUTTON, self.OnTimeToClose, endeBtn)
        self.Bind(wx.EVT_BUTTON, self.OnStartBtn, startBtn)
        
        
        # Hier wird ein Layoutmanager fuer ein tabellarisches Layout [GridSizer] verwendet.
        # Die Anzahl der Spalten wird auf 3 festgesetzt,
        # die 0 sorgt dafuer, das die Zahl der Zeilen automatisch festgelegt wird.
        sizer = wx.GridSizer(3, (0,0))
        # erste Zeile:
        sizer.Add(textStunden, 0, wx.ALIGN_CENTER,  10)
        sizer.Add(textMinuten, 0, wx.ALIGN_CENTER,  10)
        sizer.Add(textSekunden, 0, wx.ALIGN_CENTER,  10)
        # zweite Zeile:
        sizer.Add(self.textfeld1, 0, wx.ALIGN_CENTER,  10)
        sizer.Add(self.textfeld2, 0, wx.ALIGN_CENTER, 10)
        sizer.Add(self.textfeld3, 0, wx.ALIGN_CENTER,  10)
        # dritte Zeile:
        sizer.Add(startBtn, 0, wx.ALIGN_CENTER,  10)
        sizer.Add(text, 0, wx.ALIGN_CENTER, 10)
        sizer.Add(endeBtn, 0, wx.ALIGN_CENTER,  10)

        panel.SetSizer(sizer)
        panel.Layout()


    def OnTimeToClose(self, evt):
        """Ereignisbehandlung fuer den Ende-Button."""
        self.anhalten=True
        time.sleep(1)
        _thread.exit()
        self.Close()

    def OnStartBtn(self, evt):
        """Ereignisbehandlung fuer den StartBtn."""
        if self.uhrThread==None:
            self.anhalten=False
            self.uhrThread=_thread.start_new_thread(self.UhrStarten, ())
        else:
            self.anhalten=True
            self.uhrThread=None
        

    def UhrStarten(self):
        uhr=Uhr()
        while self.anhalten!=True:
            time.sleep(1)
            uhr.zaehle()
            aktuelleZeit=uhr.zeigeStand()
            self.textfeld1.SetValue(str(aktuelleZeit[0]))
            self.textfeld2.SetValue(str(aktuelleZeit[1]))
            self.textfeld3.SetValue(str(aktuelleZeit[2]))


class MyApp(wx.App):
    def OnInit(self):
        frame = Fenster(None, "Uhr Version AL")
        self.SetTopWindow(frame)
        frame.Show(True)
        return True
        
app = MyApp(redirect=False)
# Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
app.MainLoop()

